// pwratl3ctl.cpp : Implementation of Cpwratl3ctl

#include "stdafx.h"
#include "Pwratl3.h"
#include "pwratl3ctl.h"

#include "stdio.h"

/////////////////////////////////////////////////////////////////////////////
// Cpwratl3ctl
HHOOK g_hHook;
CAxWindow g_wnd;
CComPtr<IWebBrowser2> m_spBrowser;


/////////////////////////////////////////////////////////////////////////////
LRESULT FAR PASCAL GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam)
{

	LPMSG lpMsg = (LPMSG) lParam;
	if ( nCode >= 0 && PM_REMOVE == wParam )
	{        
		if(lpMsg->message == WM_KEYDOWN && (lpMsg->wParam == VK_TAB || lpMsg->wParam == VK_RETURN))
		{
			if(NULL == ::GetWindow(lpMsg->hwnd, GW_CHILD))
			{
				static TCHAR szClsName[MAX_PATH];
				memset(szClsName, 0, MAX_PATH);
				::GetClassName(lpMsg->hwnd, szClsName, MAX_PATH);

				if(!lstrcmpi(_T("Internet Explorer_Server"), szClsName)) 
				{
					//CComPtr<IWebBrowser2> cpWeb;
					//HRESULT hr;
					//hr = g_wnd.QueryControl(&cpWeb);
					if(m_spBrowser)
					{                        
						CComQIPtr<IOleInPlaceActiveObject, &IID_IOleInPlaceActiveObject> spInPlaceActiveObject(m_spBrowser);
						if(spInPlaceActiveObject)
						{
							spInPlaceActiveObject->TranslateAccelerator(lpMsg);
						}
					}
				}
			}
		}
        // workaround: Can't response mouse click event on APB WEB.
        else if(lpMsg->message == WM_LBUTTONUP) {            
            if(NULL == ::GetWindow(lpMsg->hwnd, GW_CHILD))
            {
                static TCHAR szClsName[MAX_PATH];
                memset(szClsName, 0, MAX_PATH);
                ::GetClassName(lpMsg->hwnd, szClsName, MAX_PATH);		
                
                if(!lstrcmpi(_T("Internet Explorer_Server"), szClsName)) 
                {
                    //char acTmp[10];
                    //sprintf(acTmp, "%x", lpMsg->hwnd);                    
                    //::MessageBoxA(NULL, ("WM_LBUTTONDOWN"), acTmp, MB_OK);  
                    HWND hWnd = ::GetParent(lpMsg->hwnd);
                    if(hWnd) {
                        hWnd = ::GetParent(hWnd);

                        memset(szClsName, 0, MAX_PATH);
                        ::GetClassName(hWnd, szClsName, MAX_PATH);
                        
                        if(!lstrcmpi(_T("Shell Embedding"), szClsName)) {
                            ::PostMessage(hWnd, WM_LBUTTONUP, lpMsg->wParam, lpMsg->lParam);
                        }
                    }
                }
            }
        }
	}

	return CallNextHookEx(g_hHook, nCode, wParam, lParam);
}

#include "stdio.h"

STDMETHODIMP Cpwratl3ctl::Navigate(BSTR URL, VARIANT *Flags, VARIANT *TargetFrameName, VARIANT *PostData, VARIANT *Headers, int *retn)
{
	// TODO: Add your implementation code here

    if(m_spBrowser)
	{
		;
	}
	else
	{
		HRESULT hr;
		hr = g_wnd.QueryControl(&m_spBrowser);
		if( m_spBrowser == NULL )
		{
			char msg[128];
			sprintf( msg, "QueryControl ERROR. errcode=%d", GetLastError() );
			MessageBox( msg, "ERROR", MB_OK );
			*retn = -1;
			return -1;
		}
	}
	VARIANT vtUrl;
	vtUrl.vt = VT_BSTR;
	vtUrl.bstrVal = ::SysAllocString( URL );
	
	//*retn = m_spBrowser->Navigate2(&vtUrl, Flags, TargetFrameName, PostData, Headers);
	*retn = m_spBrowser->Navigate(URL, Flags, TargetFrameName, PostData, Headers);
	

	//
	Fire_NavigateComplete2( m_spBrowser, &vtUrl );

	::SysFreeString( vtUrl.bstrVal );
	//NavigateComplete2( m_spBrowser, &vtUrl );
	return S_OK;
}

STDMETHODIMP Cpwratl3ctl::NavigateComplete2(IDispatch *pDisp, VARIANT *URL)
{
	// TODO: Add your implementation code here
	return S_OK;
}

int Cpwratl3ctl::BSTR2Char(BSTR bstr, char *cstr)
{
	int i, len;
	len = SysStringLen( bstr );
	for( i = 0; i < len; i++ )
	{
		cstr[i] = (char)bstr[i];
	}
	cstr[i] = '\0';

	return i;
}
